#include "config.h"
#include "assert.h"
#include <stdio.h>
#ifdef STDC_HEADERS
#include <stdlib.h>
#endif
#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#endif
#include <ctype.h>
#include <sys/types.h>
#ifdef HAVE_SYS_UIO_H
#include <sys/uio.h>
#endif
#include "io.h"
#include "io_interface.h"
#include "io_internal.h"
#include "unix_defs.h"
#ifndef tolower
extern int tolower ARGS((int));
#endif

int IO_shut_up = 0;
static long get_offset ARGS((void *, int, int));
extern void *io_malloc ARGS((int));


extern float
get_IOfloat(iofield, data)
IOFieldPtr iofield;
void *data;
{
    float tmp;
    pbio_internal_convert_field(NULL, iofield, data, float_type,
				sizeof(float), &tmp, 0, NULL, 0, 0);
    return tmp;
}

extern double
get_IOdouble(iofield, data)
IOFieldPtr iofield;
void *data;
{
    double tmp;
    pbio_internal_convert_field(NULL, iofield, data, float_type, sizeof(tmp),
				&tmp, 0, NULL, 0, 0);
    return tmp;
}

#if SIZEOF_LONG_DOUBLE != 0
extern long double
get_IOlong_double(iofield, data)
IOFieldPtr iofield;
void *data;
{
    long double tmp;
    pbio_internal_convert_field(NULL, iofield, data, float_type, sizeof(tmp),
				&tmp, 0, NULL, 0, 0);
    return tmp;
}
#endif

extern void
put_IOdouble(iofield, d, data)
IOFieldPtr iofield;
double d;
void *data;
{
    IOgetFieldStruct tmp_src_field;
    tmp_src_field.offset = 0;
    tmp_src_field.size = sizeof(double);
    tmp_src_field.data_type = float_type;
    tmp_src_field.byte_swap = 0;
    pbio_internal_convert_field(NULL, &tmp_src_field, &d, iofield->data_type,
	  iofield->size, (char *) data + iofield->offset, 0, NULL, 0, 0);
}

#if SIZEOF_LONG_DOUBLE != 0
extern void
put_IOlong_double(iofield, d, data)
IOFieldPtr iofield;
long double d;
void *data;
{
    IOgetFieldStruct tmp_src_field;
    tmp_src_field.offset = 0;
    tmp_src_field.size = sizeof(d);
    tmp_src_field.data_type = float_type;
    tmp_src_field.byte_swap = 0;
    pbio_internal_convert_field(NULL, &tmp_src_field, &d, iofield->data_type,
	  iofield->size, (char *) data + iofield->offset, 0, NULL, 0, 0);
}

#endif

extern short
get_IOshort(iofield, data)
IOFieldPtr iofield;
void *data;
{
    short tmp;
    pbio_internal_convert_field(NULL, iofield, data, integer_type, sizeof(tmp),
				&tmp, 0, NULL, 0, 0);
    return tmp;
}

extern unsigned short
get_IOushort(iofield, data)
IOFieldPtr iofield;
void *data;
{
    unsigned short tmp;
    pbio_internal_convert_field(NULL, iofield, data, unsigned_type,
				sizeof(tmp), &tmp, 0, NULL, 0, 0);
    return tmp;
}

extern int
get_IOint(iofield, data)
IOFieldPtr iofield;
void *data;
{
    int tmp;
    pbio_internal_convert_field(NULL, iofield, data, integer_type, sizeof(tmp),
				&tmp, 0, NULL, 0, 0);
    return tmp;
}

extern unsigned int
get_IOuint(iofield, data)
IOFieldPtr iofield;
void *data;
{
    unsigned int tmp;
    pbio_internal_convert_field(NULL, iofield, data, unsigned_type,
				sizeof(tmp), &tmp, 0, NULL, 0, 0);
    return tmp;
}


extern long
get_IOlong(iofield, data)
IOFieldPtr iofield;
void *data;
{
    long tmp;
    pbio_internal_convert_field(NULL, iofield, data, integer_type, sizeof(tmp),
				&tmp, 0, NULL, 0, 0);
    return tmp;
}

extern unsigned long
get_IOulong(iofield, data)
IOFieldPtr iofield;
void *data;
{
    unsigned long tmp;
    pbio_internal_convert_field(NULL, iofield, data, unsigned_type,
				sizeof(tmp), &tmp, 0, NULL, 0, 0);
    return tmp;
}

#if SIZEOF_LONG_LONG != 0
extern long long
get_IOlong_long(iofield, data)
IOFieldPtr iofield;
void *data;
{
    long long tmp;
    pbio_internal_convert_field(NULL, iofield, data, integer_type, sizeof(tmp),
				&tmp, 0, NULL, 0, 0);
    return tmp;
}

extern unsigned long long
get_IOulong_long(iofield, data)
IOFieldPtr iofield;
void *data;
{
    unsigned long long tmp;
    pbio_internal_convert_field(NULL, iofield, data, unsigned_type,
				sizeof(tmp), &tmp, 0, NULL, 0, 0);
    return tmp;
}

#endif

extern void
put_IOshort(iofield, d, data)
IOFieldPtr iofield;
int d;
void *data;
{
    IOgetFieldStruct tmp_src_field;
    tmp_src_field.offset = 0;
    tmp_src_field.size = sizeof(d);
    tmp_src_field.data_type = integer_type;
    tmp_src_field.byte_swap = 0;
    pbio_internal_convert_field(NULL, &tmp_src_field, &d, iofield->data_type,
	  iofield->size, (char *) data + iofield->offset, 0, NULL, 0, 0);
}

extern void
put_IOushort(iofield, d, data)
IOFieldPtr iofield;
unsigned int d;
void *data;
{
    IOgetFieldStruct tmp_src_field;
    tmp_src_field.offset = 0;
    tmp_src_field.size = sizeof(d);
    tmp_src_field.data_type = integer_type;
    tmp_src_field.byte_swap = 0;
    pbio_internal_convert_field(NULL, &tmp_src_field, &d, iofield->data_type,
	  iofield->size, (char *) data + iofield->offset, 0, NULL, 0, 0);
}

extern void
put_IOint(iofield, d, data)
IOFieldPtr iofield;
int d;
void *data;
{
    IOgetFieldStruct tmp_src_field;
    tmp_src_field.offset = 0;
    tmp_src_field.size = sizeof(d);
    tmp_src_field.data_type = integer_type;
    tmp_src_field.byte_swap = 0;
    pbio_internal_convert_field(NULL, &tmp_src_field, &d, iofield->data_type,
	  iofield->size, (char *) data + iofield->offset, 0, NULL, 0, 0);
}

extern void
put_IOuint(iofield, d, data)
IOFieldPtr iofield;
unsigned int d;
void *data;
{
    IOgetFieldStruct tmp_src_field;
    tmp_src_field.offset = 0;
    tmp_src_field.size = sizeof(d);
    tmp_src_field.data_type = integer_type;
    tmp_src_field.byte_swap = 0;
    pbio_internal_convert_field(NULL, &tmp_src_field, &d, iofield->data_type,
	  iofield->size, (char *) data + iofield->offset, 0, NULL, 0, 0);
}


extern void
put_IOlong(iofield, d, data)
IOFieldPtr iofield;
long d;
void *data;
{
    IOgetFieldStruct tmp_src_field;
    tmp_src_field.offset = 0;
    tmp_src_field.size = sizeof(d);
    tmp_src_field.data_type = integer_type;
    tmp_src_field.byte_swap = 0;
    pbio_internal_convert_field(NULL, &tmp_src_field, &d, iofield->data_type,
	  iofield->size, (char *) data + iofield->offset, 0, NULL, 0, 0);
}

extern void
put_IOulong(iofield, d, data)
IOFieldPtr iofield;
unsigned long d;
void *data;
{
    IOgetFieldStruct tmp_src_field;
    tmp_src_field.offset = 0;
    tmp_src_field.size = sizeof(d);
    tmp_src_field.data_type = integer_type;
    tmp_src_field.byte_swap = 0;
    pbio_internal_convert_field(NULL, &tmp_src_field, &d, iofield->data_type,
	  iofield->size, (char *) data + iofield->offset, 0, NULL, 0, 0);
}

extern void
get_IOlong8(iofield, data, low_long, high_long)
IOFieldPtr iofield;
void *data;
unsigned long *low_long;
long *high_long;
{
    *low_long = 0;
    if (high_long)
	*high_long = 0;
    if (iofield->data_type == integer_type) {
	if (iofield->size == 2 * sizeof(long)) {
	    int low_bytes_offset = iofield->offset;
	    int high_bytes_offset = iofield->offset;
	    IOgetFieldStruct tmp_iofield;
	    tmp_iofield = *iofield;
#ifdef WORDS_BIGENDIAN
	    if (iofield->byte_swap) {
		high_bytes_offset += sizeof(long);
	    } else {
		low_bytes_offset += sizeof(long);
	    }
#else
	    if (iofield->byte_swap) {
		high_bytes_offset += sizeof(long);
	    } else {
		low_bytes_offset += sizeof(long);
	    }
#endif
	    tmp_iofield.size = sizeof(long);
	    tmp_iofield.offset = low_bytes_offset;
	    *low_long = get_IOulong(&tmp_iofield, data);
	    if (high_long) {
		tmp_iofield = *iofield;
		tmp_iofield.size = sizeof(long);
		tmp_iofield.offset = high_bytes_offset;
		*high_long = get_IOlong(&tmp_iofield, data);
	    }
	} else {
	    *low_long = get_IOlong(iofield, data);
	}
    } else if (iofield->data_type == float_type) {
	MAX_FLOAT_TYPE tmp;
	pbio_internal_convert_field(NULL, iofield, data, float_type,
				    sizeof(tmp), &tmp, 0, NULL, 0, 0);
	*low_long = (long) tmp;
    } else {
	fprintf(stderr, "Get IOlong8 failed on invalid data type!\n");
	exit(1);
    }
}

extern void
put_IOlong8(iofield, data, low_long, high_long)
IOFieldPtr iofield;
void *data;
unsigned long low_long;
long high_long;
{
    if ((iofield->data_type == integer_type) || 
	(iofield->data_type == unsigned_type)) {
	if (iofield->size == 2 * sizeof(long)) {
	    int low_bytes_offset = iofield->offset;
	    int high_bytes_offset = iofield->offset;
#ifdef WORDS_BIGENDIAN
	    if (iofield->byte_swap) {
		high_bytes_offset += sizeof(long);
	    } else {
		low_bytes_offset += sizeof(long);
	    }
#else
	    if (iofield->byte_swap) {
		high_bytes_offset += sizeof(long);
	    } else {
		low_bytes_offset += sizeof(long);
	    }
#endif
	    memcpy((char *) data + low_bytes_offset, &low_long, sizeof(long));
	    memcpy((char *) data + high_bytes_offset, &high_long,
		   sizeof(long));
	} else {
	    put_IOlong(iofield, low_long, data);
	}
    } else {
	fprintf(stderr, "Put IOlong8 failed on invalid data type!\n");
	exit(1);
    }
}

extern int
get_IOulong8(iofield, data, low_long, high_long)
IOFieldPtr iofield;
void *data;
unsigned long *low_long;
unsigned long *high_long;
{
    *low_long = 0;
    if (high_long)
	*high_long = 0;
    if (iofield->data_type == unsigned_type) {
	if (iofield->size == 2 * sizeof(long)) {
	    int low_bytes_offset = iofield->offset;
	    int high_bytes_offset = iofield->offset;
	    IOgetFieldStruct tmp_iofield;
	    tmp_iofield = *iofield;
#ifdef WORDS_BIGENDIAN
	    if (iofield->byte_swap) {
		high_bytes_offset += sizeof(long);
	    } else {
		low_bytes_offset += sizeof(long);
	    }
#else
	    if (iofield->byte_swap) {
		high_bytes_offset += sizeof(long);
	    } else {
		low_bytes_offset += sizeof(long);
	    }
#endif
	    tmp_iofield.size = sizeof(unsigned long);
	    tmp_iofield.offset = low_bytes_offset;
	    *low_long = get_IOulong(&tmp_iofield, data);
	    if (high_long) {
		tmp_iofield = *iofield;
		tmp_iofield.size = sizeof(unsigned long);
		tmp_iofield.offset = high_bytes_offset;
		*high_long = get_IOulong(&tmp_iofield, data);
	    }
	    return 0;
	} else {
	    *low_long = get_IOulong(iofield, data);
	    return 0;
	}
    } else if (iofield->data_type == integer_type) {
	/* this is a bit to ugly to handle at the moment.. */
	assert(FALSE);
	return 0;
    } else if (iofield->data_type == float_type) {
	MAX_FLOAT_TYPE tmp;
	pbio_internal_convert_field(NULL, iofield, data, float_type,
				    sizeof(tmp), &tmp, 0, NULL, 0, 0);
	*low_long = (long) tmp;
	return 0;
    } else {
	fprintf(stderr, "Get IOlong8 failed on invalid data type!\n");
	exit(1);
    }
    /* NOTREACHED */
    return 0;
}

extern char
get_IOchar(iofield, data)
IOFieldPtr iofield;
void *data;
{
    if (iofield->data_type == char_type) {
	return (char) *((char *) data + iofield->offset);
    } else {
	fprintf(stderr, "Get Char failed on invalid data type!\n");
	exit(1);
    }
    /* NOTREACHED */
    return 0;
}

extern void
put_IOchar(iofield, c, data)
IOFieldPtr iofield;
int c;
void *data;
{
    if (iofield->data_type == char_type) {
	*((char *) data + iofield->offset) = c;
    } else {
	fprintf(stderr, "Put Char failed on invalid data type!\n");
	exit(1);
    }
}

extern int
get_IOenum(iofield, data)
IOFieldPtr iofield;
void *data;
{
    IOgetFieldStruct tmp_iofield;
    tmp_iofield = *iofield;
    tmp_iofield.data_type = integer_type;
    return get_IOint(&tmp_iofield, data);
}

extern void
put_IOenum(iofield, enm, data)
IOFieldPtr iofield;
int enm;
void *data;
{
    IOgetFieldStruct tmp_iofield;
    tmp_iofield = *iofield;
    tmp_iofield.data_type = integer_type;
    put_IOint(&tmp_iofield, enm, data);
}

extern char *
get_IOstring(iofield, data)
IOFieldPtr iofield;
void *data;
{
    return get_IOstring_base(iofield, data, data);
}

extern char *
get_IOstring_base(iofield, data, string_base)
IOFieldPtr iofield;
void *data;
void *string_base;
{
    unsigned long offset = get_offset((void *) ((char *) data + iofield->offset),
			     iofield->size, iofield->byte_swap);
    if (offset == 0) {
	return NULL;
    } else if (offset > (unsigned long) data) {		/* probably *
							 * converted *
							 * string */
	return (char *) offset;
    } else {
	return (char *) string_base + offset;
    }
}

extern void
put_IOstring(iofield, str, data)
IOFieldPtr iofield;
char *str;
void *data;
{
    assert(iofield->size >= sizeof(char *));
    /* we just can't handle this in a put field if the string size  in the 
     * 
     * * record isn't as big or bigger than the local one... */

    if (iofield->size == sizeof(char *)) {
	/* move in the address */
	memcpy((char *) data + iofield->offset, &str, sizeof(char *));
    } else {
	/* zero the field in the record */
	memset((char *) data + iofield->offset, 0, iofield->size);

	if (sizeof(char *) == sizeof(long)) {
	    put_IOlong(iofield, (long) str, data);
	} else if (sizeof(char *) == sizeof(int)) {
	    put_IOint(iofield, (long) str, data);
	} else {
	    assert(FALSE);
	}
    }
}

static long
get_offset(data, size, swap)
void *data;
int size;
int swap;
{
    IOgetFieldStruct field;
    field.offset = 0;
    field.size = size;
    field.data_type = integer_type;
    field.byte_swap = swap;
    if (size == sizeof(int)) {
	return get_IOlong(&field, data);
    } else {
	field.offset = size - sizeof(long);
	field.size = sizeof(long);
	return get_IOlong(&field, data);
    }
}

extern IOdata_type
str_to_data_type(str)
char *str;
{
    char *tmp = io_malloc(strlen(str) + 1);
    strcpy(tmp, str);
    str = tmp;			/* make a copy of str parameter */

    while (isspace(*str)) {	/* skip preceeding space */
	str++;
    }
    tmp = str + strlen(str) - 1;
    while (isspace(*tmp)) {	/* kill trailing space */
	*tmp = 0;
	tmp--;
    }
    tmp = str;
    while (*tmp) {		/* map to lower case */
	*tmp = tolower(*tmp);
	tmp++;
    }
    if (strcmp(str, "integer") == 0) {
	io_free(str);
	return integer_type;
    } else if (strcmp(str, "unsigned integer") == 0) {
	io_free(str);
	return unsigned_type;
    } else if (strcmp(str, "float") == 0) {
	io_free(str);
	return float_type;
    } else if (strcmp(str, "double") == 0) {
	io_free(str);
	return float_type;
    } else if (strcmp(str, "char") == 0) {
	io_free(str);
	return char_type;
    } else if (strcmp(str, "string") == 0) {
	io_free(str);
	return string_type;
    } else if (strcmp(str, "enumeration") == 0) {
	io_free(str);
	return enumeration_type;
    } else {
	io_free(str);
	return unknown_type;
    }
}

extern int
IO_field_type_eq(str1, str2)
char *str1;
char *str2;
{
    IOdata_type t1, t2;
    int t1_dimen1, t1_dimen2;
    int t2_dimen1, t2_dimen2;

    t1 = array_str_to_data_type(str1, &t1_dimen1, &t1_dimen2);
    t2 = array_str_to_data_type(str2, &t2_dimen1, &t2_dimen2);

    if ((t1_dimen1 == -1) && (t2_dimen1 == -1)) {
	/* variant array */
	return (strcmp(str1, str2) == 0);
    }
    return ((t1 == t2) && (t1_dimen1 == t2_dimen1) &&
	    (t1_dimen2 == t2_dimen2));
}

extern char *
base_data_type(str)
char *str;
{
    char *typ = strdup(str);
    if (strchr(typ, '[') != NULL) {	/* truncate at array stuff */
	*strchr(typ, '[') = 0;
    }
    return typ;
}

extern IOdata_type
array_str_to_data_type(str, dimen1_ptr, dimen2_ptr)
char *str;
int *dimen1_ptr;
int *dimen2_ptr;
{
    IOdata_type ret_type;
    char field_type[1024];
    char *left_paren;
    if ((left_paren = strchr(str, '[')) == NULL) {
	*dimen1_ptr = *dimen2_ptr = 1;
	ret_type = str_to_data_type(str);
    } else if (strchr(left_paren + 1, '[') == NULL) {
	/* single dimen array */
	int dimension = 0;
	int i = 0;
	char *tmp = str;
	for( ; tmp < left_paren; tmp++) {
	    field_type[i++] = *tmp;
	}
	field_type[i] = 0;
	if (sscanf(left_paren + 1, "%d]", &dimension) != 1) {
	    ret_type = str_to_data_type(field_type);
	    *dimen1_ptr = -1;
	    *dimen2_ptr = 1;
	} else {
	    ret_type = str_to_data_type(field_type);
	    *dimen1_ptr = dimension;
	    *dimen2_ptr = 1;
	}
    } else {
	/* double dimen array */
	int dimension1 = 0;
	int dimension2 = 0;
	int i = 0;
	char *tmp = str;
	for( ; tmp < left_paren; tmp++) {
	    field_type[i++] = *tmp;
	}
	field_type[i] = 0;
	if (sscanf(left_paren + 1, "%d][%d]", &dimension1, &dimension2) != 2) {
	    fprintf(stderr, "Couldn't parse array size in \"%s\"\n", str);
	    *dimen1_ptr = 0;
	    *dimen2_ptr = 0;
	    ret_type = str_to_data_type(field_type);
	} else {
	    ret_type = str_to_data_type(field_type);
	    *dimen1_ptr = dimension1;
	    *dimen2_ptr = dimension2;
	}
    }
    return ret_type;
}

extern int
get_var_array_control(str, fields)
char *str;
IOFieldList fields;
{
    char field_name[1024];
    char *left_paren;
    int junk;

    if ((left_paren = strchr(str, '[')) == NULL) {
	return -1;
    } else if (strchr(left_paren + 1, '[') == NULL) {
	/* single dimen array */

	if (sscanf(left_paren + 1, "%d]", &junk) != 1) {
	    int count = 0;
	    int i = 0;
	    while (((left_paren+1)[count] != ']') &&
		   ((left_paren+1)[count] != 0)) {
		field_name[count] = (left_paren+1)[count];
		count++;
	    }
	    field_name[count] = 0;
	    while (fields[i].field_name != NULL) {
		if (strcmp(field_name, fields[i].field_name) == 0) {
		    if (str_to_data_type(fields[i].field_type) ==
			integer_type) {
			return i;
		    } else {
			fprintf(stderr, "Variable length control field \"%s\"not of integer type.\n", field_name);
			return -1;
		    }
		}
		i++;
	    }
	} else {
	    return -1;
	}
    } else {
	return -1;
    }
    return -1;
}

extern char *
data_type_to_str(dat)
IOdata_type dat;
{
    switch (dat) {
    case integer_type:
	return "integer";
    case unsigned_type:
	return "unsigned integer";
    case float_type:
	return "float";
    case char_type:
	return "char";
    case string_type:
	return "string";
    case enumeration_type:
	return "enumeration";
    default:
	return "unknown_type";
    }
}

extern IOFieldPtr
get_IOfieldPtrFromList(field_list, fieldname)
IOFieldList field_list;
char *fieldname;
{
    int index;
    IOFieldPtr ret_val;
    IOdata_type data_type;

    for (index = 0; field_list[index].field_name != NULL; index++) {
	if (strcmp(field_list[index].field_name, fieldname) == 0) {
	    break;
	}
    }
    if (field_list[index].field_name == NULL)
	return NULL;

    data_type = str_to_data_type(field_list[index].field_type);
    if (data_type == unknown_type) {
	fprintf(stderr, "Unknown field type for field %s\n",
		field_list[index].field_name);
	return NULL;
    }
    ret_val = (IOFieldPtr) io_malloc(sizeof(*ret_val));
    ret_val->offset = field_list[index].field_offset;
    ret_val->size = field_list[index].field_size;
    ret_val->data_type = data_type;
    ret_val->byte_swap = FALSE;
    return ret_val;
}

extern IOFieldPtr
get_IOfieldPtr(iofile, formatname, fieldname)
IOFile iofile;
char *formatname;
char *fieldname;
{
    IOFormat format = get_IOformat_by_name(iofile, formatname);
    int index;
    IOFieldPtr ret_val;
    IOdata_type data_type;
    int junk;

    if (format == NULL)
	return NULL;

    for (index = 0; index < format->field_count; index++) {
	if (strcmp(format->field_list[index].field_name,
		   fieldname) == 0) {
	    break;
	}
    }
    if (index >= format->field_count)
	return NULL;

    data_type = array_str_to_data_type(format->field_list[index].field_type,
				       &junk, &junk);
    if (data_type == unknown_type) {
	fprintf(stderr, "Unknown field type for field %s\n",
		format->field_list[index].field_name);
	return NULL;
    }
    ret_val = (IOFieldPtr) io_malloc(sizeof(*ret_val));
    ret_val->offset = format->field_list[index].field_offset;
    ret_val->size = format->field_list[index].field_size;
    ret_val->data_type = data_type;
    ret_val->byte_swap = iofile->byte_reversal;
    return ret_val;
}

extern IOFieldPtr
get_local_IOfieldPtr(iofile, formatname, fieldname)
IOFile iofile;
char *formatname;
char *fieldname;
{
    IOFieldPtr ret_val = get_IOfieldPtr(iofile, formatname, fieldname);

    /* 
     * get_local_IOfieldPtr() differs from get_IOfieldPtr() only in
     * that the byte_swap value is always false.  This is because
     * local IOfield ptrs are to be used with the records returned
     * from local conversions.  A local conversion already has
     * performed the byte_swapping. 
     */
    if (ret_val)
	ret_val->byte_swap = FALSE;
    return ret_val;
}
